#ifndef _MAIN_H
#define _MAIN_H

#include "include_gl.h"
#include <algorithm>
#include <string>

namespace Option {
  extern bool perspective;
  extern bool flat_shading;
  extern float zoom;
}

struct GlApp {
  static GlApp* singleton;

  GlApp();
  virtual ~GlApp();
  void go();
  
  virtual void setup_gl();
  virtual bool set_flag(const string& flag);
  
  virtual const char* window_name() const { return "Generic App"; }
  virtual pair<int,int> window_size() const { return make_pair(700, 700); }

  int window_width, window_height;
  int frame;
  
  virtual void idle_handler();
  virtual void setup_projection();
  virtual void setup_view();
  
  virtual void event_paint_window();
  virtual void event_window_resize(int width, int height);
  virtual void event_mouse_motion(int x, int y);
  virtual void event_mouse_button(int button, int state, int x, int y);
  virtual void event_key(unsigned char key, int x, int y, bool down);
  virtual void event_special_key(int key, int x, int y, bool down);
  
  virtual void update_selection();
  virtual void paint_annotation();
  virtual void paint_content();
};

GlApp* getGlAppInstance();
double current_time();

#endif
